Class | Sass::Script::Lexer
In: | lib/sass/script/lexer.rb
Parent: | Object

The lexical analyzer for SassScript. It takes a raw string and converts it to individual tokens that are easier to parse.

### Methods

after_interpolation? done? expected! new next peek str unpeek! whitespace?

### Included Modules

Sass::SCSS::RX

### Constants

Token

=

Struct.new(:type, :value, :line, :offset, :pos)

A struct containing information about an individual token.

`type`: \[`Symbol`\] : The type of token.

`value`: \[`Object`\] : The Ruby object corresponding to the value of the token.

`line`: \[`Fixnum`\] : The line of the source file on which the token appears.

`offset`: \[`Fixnum`\] : The number of bytes into the line the SassScript token appeared.

`pos`: \[`Fixnum`\] : The scanner position at which the SassScript token appeared.

OPERATORS

=

{ '+' => :plus, '-' => :minus, '*' => :times, '/' => :div, '%' => :mod, '=' => :single_eq, ':' => :colon, '(' => :lparen, ')' => :rparen, ',' => :comma, 'and' => :and, 'or' => :or, 'not' => :not, '==' => :eq, '!=' => :neq, '>=' => :gte, '<=' => :lte, '>' => :gt, '<' => :lt, '#{' => :begin_interpolation, '}' => :end_interpolation, ';' => :semicolon, '{' => :lcurly, }

A hash from operator strings to the corresponding token types.

OPERATORS_REVERSE | = | Haml::Util.map_hash(OPERATORS) {|k, v| [v, k]}
TOKEN_NAMES | = | Haml::Util.map_hash(OPERATORS_REVERSE) {|k, v| [k, v.inspect]}.merge({ :const => "variable (e.g. $foo)", :ident => "identifier (e.g. middle)", :bool => "boolean (e.g. true, false)", })
OP_NAMES | = | OPERATORS.keys.sort_by {|o| -o.size} |  | A list of operator strings ordered with longer names first so that `>` and `<` don‘t clobber `>=` and `<=`.
IDENT_OP_NAMES | = | OP_NAMES.select {|k, v| k =~ /^\w+/} |  | A sub-list of {OP_NAMES} that only includes operators with identifier names.

REGULAR_EXPRESSIONS

=

{ :whitespace => /\s+/, :comment => COMMENT, :single_line_comment => SINGLE_LINE_COMMENT, :variable => /([!\$])(#{IDENT})/, :ident => /(#{IDENT})(\()?/, :number => /(-)?(?:(\d*\.\d+)|(\d+))([a-zA-Z%]+)?/, :color => HEXCOLOR, :bool => /(true|false)\b/, :ident_op => %r{(#{Regexp.union(*IDENT_OP_NAMES.map{|s| Regexp.new(Regexp.escape(s) + '(?:\b|$)')})})}, :op => %r{(#{Regexp.union(*OP_NAMES)})}, }

A hash of regular expressions that are used for tokenizing.

STRING_REGULAR_EXPRESSIONS

=

{ [:double, false] => string_re('"', '"'), [:single, false] => string_re("'", "'"), [:double, true] => string_re('', '"'), [:single, true] => string_re('', "'"), [:uri, false] => /url\(#{W}(#{URLCHAR}*?)(#{W}\)|#\{)/, [:uri, true] => /(#{URLCHAR}*?)(#{W}\)|#\{)/, }

A hash of regular expressions that are used for tokenizing strings.

The key is a `[Symbol, Boolean]` pair. The symbol represents which style of quotation to use, while the boolean represents whether or not the string is following an interpolated segment.

### Attributes

line | [R] | The line number of the lexer‘s current position. @return [Fixnum]
offset | [R] | The number of bytes into the current line of the lexer‘s current position. @return [Fixnum]

### Public Class methods

new(str, line, offset, options)

@param str [String, StringScanner] The source text to lex @param line [Fixnum] The line on which the SassScript appears.

      Used for error reporting

@param offset [Fixnum] The number of characters in on which the SassScript appears.

      Used for error reporting

@param options [{Symbol => Object}] An options hash;

      see {file:SASS_REFERENCE.md#sass_options the Sass options documentation}

[Source]

         # File lib/sass/script/lexer.rb, line 128
    128:       def initialize(str, line, offset, options)
    129:         @scanner = str.is_a?(StringScanner) ? str : StringScanner.new(str)
    130:         @line = line
    131:         @offset = offset
    132:         @options = options
    133:         @interpolation_stack = []
    134:         @prev = nil
    135:       end

### Public Instance methods

after_interpolation?()

@return [Boolean] Whether or not the last token lexed was `:end_interpolation`.

[Source]

         # File lib/sass/script/lexer.rb, line 179
    179:       def after_interpolation?
    180:         @prev && @prev.type == :end_interpolation
    181:       end

done?()

@return [Boolean] Whether or not there‘s more source text to lex.

[Source]

         # File lib/sass/script/lexer.rb, line 173
    173:       def done?
    174:         whitespace unless after_interpolation? && @interpolation_stack.last
    175:         @scanner.eos? && @tok.nil?
    176:       end

expected!(name)

Raise an error to the effect that `name` was expected in the input stream and wasn‘t found.

This calls \{unpeek!} to rewind the scanner to immediately after the last returned token.

@param name [String] The name of the entity that was expected but not found @raise [Sass::SyntaxError]

[Source]

         # File lib/sass/script/lexer.rb, line 191
    191:       def expected!(name)
    192:         unpeek!
    193:         Sass::SCSS::Parser.expected(@scanner, name, @line)
    194:       end

next()

Moves the lexer forward one token.

@return [Token] The token that was moved past

[Source]

         # File lib/sass/script/lexer.rb, line 140
    140:       def next
    141:         @tok ||= read_token
    142:         @tok, tok = nil, @tok
    143:         @prev = tok
    144:         return tok
    145:       end

peek()

Returns the next token without moving the lexer forward.

@return [Token] The next token

[Source]

         # File lib/sass/script/lexer.rb, line 162
    162:       def peek
    163:         @tok ||= read_token
    164:       end

str() {|| ...}

Records all non-comment text the lexer consumes within the block and returns it as a string.

@yield A block in which text is recorded @return [String]

[Source]

         # File lib/sass/script/lexer.rb, line 201
    201:       def str
    202:         old_pos = @tok ? @tok.pos : @scanner.pos
    203:         yield
    204:         new_pos = @tok ? @tok.pos : @scanner.pos
    205:         @scanner.string[old_pos...new_pos]
    206:       end

unpeek!()

Rewinds the underlying StringScanner to before the token returned by \{peek}.

[Source]

         # File lib/sass/script/lexer.rb, line 168
    168:       def unpeek!
    169:         @scanner.pos = @tok.pos if @tok
    170:       end

whitespace?(tok = @tok)

Returns whether or not there‘s whitespace before the next token.

@return [Boolean]

[Source]

         # File lib/sass/script/lexer.rb, line 150
    150:       def whitespace?(tok = @tok)
    151:         if tok
    152:           @scanner.string[0...tok.pos] =~ /\s\Z/
    153:         else
    154:           @scanner.string[@scanner.pos, 1] =~ /^\s/ ||
    155:             @scanner.string[@scanner.pos - 1, 1] =~ /\s\Z/
    156:         end
    157:       end

[Validate]